SoOrthographicCamera(3)

NAME
SoOrthographicCamera - The SoOrthographicCamera class defines a camera node with orthographic rendering.

SYNOPSIS

#include <Inventor/nodes/SoOrthographicCamera.h>

Inherits SoCamera.

  Public Member Functions
virtual SoType getTypeId (void) const
SoOrthographicCamera (void)
virtual void scaleHeight (float scalefactor)
virtual SbViewVolume getViewVolume (float useaspectratio=0.0f) const
virtual void viewBoundingBox (const SbBox3f &box, float aspect, float slack)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFFloat height

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoOrthographicCamera ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoOrthographicCamera class defines a camera node with orthographic rendering. Orthographic rendering will not give a particularly realistic impression of the scene, but non-realistic rendering is for various reasons widely used in applications for e.g. Computer Aided Design.

Also, a simple technique for drawing overlay / HUD style graphics (often appearing to be in 2D) can be implemented by setting up a 'sub scene graph' with an SoOrthographicCamera and the geometry. As a simple demonstration of this concept, load this file into e.g. the ExaminerViewer:

#Inventor V2.1 ascii
Separator {
   PerspectiveCamera { position 0 0 5 }
   Cone { }
   Separator {
      OrthographicCamera {
         position -0.75 -0.75 2
      }
      BaseColor { rgb 1 1 0 }
      Sphere { radius 0.2 }
   }
}

You will likely encounter z-buffer issues with this technique which makes the overlay / HUD graphics end up interspersed with the 'real' geometry. If so, this can be solved by e.g. inserting an SoCallback node in the sub-scene, where you let the callback disable the depth buffer with glDisable(GL_DEPTH_TEST).

FILE FORMAT/DEFAULTS:

OrthographicCamera {
    viewportMapping ADJUST_CAMERA
    position 0 0 1
    orientation 0 0 1  0
    nearDistance 1
    farDistance 10
    aspectRatio 1
    focalDistance 5
    height 2
}

Constructor & Destructor Documentation

  SoOrthographicCamera::SoOrthographicCamera (void)
Constructor.

  SoOrthographicCamera::~SoOrthographicCamera () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoOrthographicCamera::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoOrthographicCamera::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoCamera.

  const SoFieldData ** SoOrthographicCamera::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoOrthographicCamera::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoCamera.

  void SoOrthographicCamera::scaleHeight (float scalefactor) [virtual]
Scale SoOrthographicCamera::height by multiplying with scalefactor.

Implements SoCamera.

  SbViewVolume SoOrthographicCamera::getViewVolume (float useaspectratio = 0.0f) const [virtual]
Returns total view volume covered by the camera under the current settings.

This view volume is not adjusted to account for viewport mapping. If you want the same view volume as the one used during rendering, you should use getViewVolume(SbViewportRegion & vp, const SbMatrix & mm), or do something like this:

SbViewVolume vv;
float aspectratio = myviewport.getViewportAspectRatio();
switch (camera->viewportMapping.getValue()) {
case SoCamera::CROP_VIEWPORT_FILL_FRAME:
case SoCamera::CROP_VIEWPORT_LINE_FRAME:
case SoCamera::CROP_VIEWPORT_NO_FRAME:
  vv = camera->getViewVolume(0.0f);
  break;
case SoCamera::ADJUST_CAMERA:
  vv = camera->getViewVolume(aspectratio);
  if (aspectratio < 1.0f) vv.scale(1.0f / aspectratio);
  break;
case SoCamera::LEAVE_ALONE:
  vv = camera->getViewVolume(0.0f);
  break;
default:
  assert(0 && 'unknown viewport mapping');
  break;
}.fi

Also, for the CROPPED viewport mappings, the viewport might be changed if the viewport aspect ratio is not equal to the camera aspect ratio. See the SoCamera::getView() source-code (private method) to see how this is done.

Implements SoCamera.

  void SoOrthographicCamera::viewBoundingBox (const SbBox3f & box, float aspect, float slack) [virtual]
Convenience method for setting up the camera definition to cover the given bounding box with the given aspect ratio. Multiplies the exact dimensions with a slack factor to have some space between the rendered model and the borders of the rendering area.

If you define your own camera node class, be aware that this method should not set the orientation field of the camera, only the position, focal distance and near and far clipping planes.

Implements SoCamera.

Member Data Documentation

  SoSFFloat SoOrthographicCamera::height
Height of viewport in world space scale. Defaults to 2.0 units.

Author

Generated automatically by Doxygen for Coin from the source code.